﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using System.Reflection;
using System.IO;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.AppStyling;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        private DataTable dt1;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(10, new Type[] { typeof(DateTime) });

            dt1.TableName = "Band 0";            
            dt1.Rows[2]["DateTime 1"] = DateTime.MinValue;
            dt1.AcceptChanges();
            this.ultraGrid1.DataSource = dt1;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];
            var ov = layout.Override;
                        
            var realDateColumn = band.Columns["DateTime 1"];
            UltraGridColumn unboundDateColumn;
            if (band.Columns.Exists("User DateTime"))
                unboundDateColumn = band.Columns["User DateTime"];
            else
            {
                unboundDateColumn = band.Columns.Add("User DateTime");
                unboundDateColumn.DataType = typeof(DateTime);
                unboundDateColumn.Header.VisiblePosition = realDateColumn.Header.VisiblePosition;
            }

            //realDateColumn.Hidden = true;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            // Copy the "Real" value into the unbound date cell to display for the user. 
            if (false == e.ReInitialize &&
                e.Row.Cells.Exists("User DateTime"))
            {
                var realDateCell = e.Row.Cells["DateTime 1"];
                var userDateCell = e.Row.Cells["User DateTime"];
                var realDate = (DateTime)realDateCell.Value;
                if (realDate == DateTime.MinValue)
                    userDateCell.Value = DBNull.Value;
                else
                    userDateCell.Value = realDate;
            }
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            // If the user edits the unbound date column, copy the value into the "real" column for
            // updating. 
            if (e.Cell.Column.Key == "User DateTime")
            {
                var userDate = e.Cell.Value;
                if (userDate is DBNull)
                    e.Cell.Row.Cells["DateTime 1"].Value = DateTime.MinValue;
                else
                    e.Cell.Row.Cells["DateTime 1"].Value = userDate;
            }
                
        }
    }
}

